import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
} from "@smithy/types";
import { SageMakerA2IRuntimeClientResolvedConfig } from "../SageMakerA2IRuntimeClient";
export interface SageMakerA2IRuntimeHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface SageMakerA2IRuntimeHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    SageMakerA2IRuntimeClientResolvedConfig,
    HandlerExecutionContext,
    SageMakerA2IRuntimeHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultSageMakerA2IRuntimeHttpAuthSchemeParametersProvider: (
  config: SageMakerA2IRuntimeClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<SageMakerA2IRuntimeHttpAuthSchemeParameters>;
export interface SageMakerA2IRuntimeHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<SageMakerA2IRuntimeHttpAuthSchemeParameters> {}
export declare const defaultSageMakerA2IRuntimeHttpAuthSchemeProvider: SageMakerA2IRuntimeHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: SageMakerA2IRuntimeHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: SageMakerA2IRuntimeHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
